#ifndef bqtQBlibErrorHH
#define bqtQBlibErrorHH

#include <qblib/types.hh>

#include <setjmp.h>
#include <cstdio>
#include <vector>

class jmp_buf_wrapper
{
private:
    jmp_buf buf;
public:
    operator jmp_buf& () { return buf; }
};

extern size_t HandlingError; /* Also doubles as the size of the error frame stack */
extern jmp_buf_wrapper ErrorSpot, SafeReturnToMain;
extern std::vector<jmp_buf_wrapper> ErrorFrameStack;
extern void* ErrorHandler, *ResumeTarget;
extern int B_ERL_VALUE, B_ERR_VALUE;

#define B_ERR_RESUME_REPEAT_CODE 1
#define B_ERR_RESUME_NEXT_CODE   2
#define B_ERR_HEADER() { if(unlikely(setjmp(SafeReturnToMain))) goto *ResumeTarget; }
#define B_ERR_BEGIN_PRE() B_ERR_PUSH();
#define B_ERR_BEGIN() if(likely(setjmp(ErrorSpot) != B_ERR_RESUME_NEXT_CODE)) {
#define B_ERR_OVER() }
#define B_ERR_OVER_POST() B_ERR_POP();

void B_RESUME_FAILTEST();
void B_ERR_PUSH();
void B_ERR_POP();
void B_RESUME();
void B_RESUME_NEXT();
void B_ERROR(BAS_INT code);

/* RESUME_TO always goes into main program */
#define B_RESUME_TO(label) \
    { B_RESUME_FAILTEST(); B_ERR_POP(); ResumeTarget=&&label; longjmp(SafeReturnToMain,1); }

#define ON_ERROR_GOTO(label) { if(likely(!HandlingError)) ErrorHandler=&&label; }
#define ON_ERROR_GOTO_NOWHERE() { ErrorHandler=0; }

#endif
